# PSF-LoginServer - master - net.psforever.objects.Tool
PSF - LoginServer - master - net.psforever.objects.Tool
Keywords: PSF LoginServer master net.psforever.objects.Tool

PSF-LoginServer - master < Back


# Packages

-  package root
  Definition Classes
    root
-  package net
  Definition Classes
    root
-  package psforever
  Definition Classes
    net
-  package objects
  Definition Classes
    psforever
-  package avatar
  Definition Classes
    objects
-  package ballistics
  Definition Classes
    objects
-  package ce
  Definition Classes
    objects
-  package definition
  Definition Classes
    objects
-  package entity
  Definition Classes
    objects
-  package equipment
  Definition Classes
    objects
-  package geometry
  Definition Classes
    objects
-  package guid
  Definition Classes
    objects
-  package inventory
  Definition Classes
    objects
-  package loadouts
  Definition Classes
    objects
-  package locker
  Definition Classes
    objects
-  package serverobject
  Definition Classes
    objects
-  package teamwork
  Definition Classes
    objects
-  package vehicles
  Definition Classes
    objects
-  package vital
  Definition Classes
    objects
-  package zones
  Definition Classes
    objects
- Account
- AmmoBox
- BoomerDeployable
- BoomerDeployableControl
- BoomerDeployableDefinition
- BoomerTrigger
- CommonNtuContainer
- ConstructionItem
- Default
- Deployables
- ExplosiveDeployable
- ExplosiveDeployableControl
- ExplosiveDeployableDefinition
- GlobalDefinitions
- Kit
- LivePlayerList
- LocalLockerItem
- LocalProjectile
- MineDeployableControl
- Ntu
- NtuContainer
- NtuContainerDefinition
- NtuStorageBehavior
- ObjectType
- OffhandEquipmentSlot
- OwnableByPlayer
- PlanetSideGameObject
- Player
- Players
- SensorDeployable
- SensorDeployableControl
- SensorDeployableDefinition
- Session
- ShieldGeneratorControl
- ShieldGeneratorDefinition
- ShieldGeneratorDeployable
- SimpleItem
- SpawnPoint
- SpawnPointDefinition
- SpecialEmp
- Telepad
- TelepadControl
- TelepadDeployable
- TelepadDeployableControl
- TelepadDeployableDefinition
- Tool
- Tools
- TrapDeployable
- TrapDeployableControl
- TrapDeployableDefinition
- TurretControl
- TurretDeployable
- TurretDeployableDefinition
- Vehicle
- Vehicles

c

net.psforever.objects

# Tool 

###
Companion object Tool

#### class Tool extends Equipment with FireModeSwitch[FireModeDefinition] with JammableUnit

A type of `Equipment` that can be wielded and loaded with certain other game elements.
"Tool" is a very mechanical name while this class is intended for various weapons and support items. The primary trait of a `Tool` is that it has something that counts as an "ammunition," depleted as the `Tool` is used, replaceable as long as one has an appropriate type of `AmmoBox` object. (The former is always called "consuming;" the latter, "reloading.") Some weapons Chainblade have ammunition but do not consume it.

Source
  Tool.scala

Linear Supertypes
JammableUnit, FireModeSwitch[FireModeDefinition], Equipment, BlockMapEntity, FactionAffinity, PlanetSideGameObject, WorldEntity, IdentifiableEntity, Identifiable, AnyRef, Any
Known Subclasses
TurretWeapon

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Tool
2. JammableUnit
3. FireModeSwitch
4. Equipment
5. BlockMapEntity
6. FactionAffinity
7. PlanetSideGameObject
8. WorldEntity
9. IdentifiableEntity
10. Identifiable
11. AnyRef
12. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new Tool(toolDef: ToolDefinition)

   toolDef

     the `ObjectDefinition` that constructs this item and maintains some of its immutable fields

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def AmmoSlot: FireModeSlot
5.  def AmmoSlots: List[FireModeSlot]
6.  def AmmoType: equipment.Ammo.Value
7.  def AmmoTypeIndex: Int
8.  def AmmoTypeIndex_=(index: Int): Int
9.  def Definition: ToolDefinition
   Definition Classes
     Tool → Equipment → PlanetSideGameObject
10.  def Destroyed: Boolean
    Definition Classes
      PlanetSideGameObject
11.  def Destroyed_=(state: Boolean): Boolean
    Definition Classes
      PlanetSideGameObject
12.  def Discharge(rounds: Option[Int] = None): Int
13.  def Entity: WorldEntity
    Definition Classes
      PlanetSideGameObject
14.  def Entity_=(newEntity: WorldEntity): Unit
    Definition Classes
      PlanetSideGameObject
15.  def Faction: types.PlanetSideEmpire.Value
    Definition Classes
      Equipment → FactionAffinity
16.  def Faction_=(fact: types.PlanetSideEmpire.Value): types.PlanetSideEmpire.Value
    Definition Classes
      Equipment → FactionAffinity
17.  def FireMode: FireModeDefinition
    Definition Classes
      Tool → FireModeSwitch
18.  def FireModeIndex: Int
    Definition Classes
      Tool → FireModeSwitch
19.  def FireModeIndex_=(index: Int): Int
    Definition Classes
      Tool → FireModeSwitch
20.  def GUID: PlanetSideGUID
    Definition Classes
      IdentifiableEntity → Identifiable
21.  def GUID_=(guid: PlanetSideGUID): PlanetSideGUID
    Definition Classes
      IdentifiableEntity → Identifiable
22.  def GUID_=(guid: StalePlanetSideGUID): PlanetSideGUID

    Always intercept `StalePlanetSideGUID` references when attempting to mutate the GUID value.

    Always intercept `StalePlanetSideGUID` references when attempting to mutate the GUID value.

    guid

      the valid GUID to assign

    returns

      never returns

    Definition Classes
      IdentifiableEntity
    Exceptions thrown

      ``AssigningGUIDException`` always

23.  def HasGUID: Boolean

    Flag when the object has no GUID (initial condition) or is considered stale.

    Flag when the object has no GUID (initial condition) or is considered stale.

    returns

      whether the value of the GUID is a valid representation for this object

    Definition Classes
      IdentifiableEntity
24.  def Invalidate(): Unit

    Indicate that the current GUID is no longer a valid representation of the object.

    Indicate that the current GUID is no longer a valid representation of the object. Transforms whatever the current GUID is into a `StalePlanetSideGUID` entity with the same value. Doing this restores the object to its default mutation option ("the ability to set a new valid GUID"). The current GUID will still be accessed as if it were valid, but it will be wrapped in the new stale object.

    Definition Classes
      IdentifiableEntity
25.  def Jammed: Boolean
    Definition Classes
      JammableUnit
26.  def Jammed_=(state: Boolean): Boolean
    Definition Classes
      JammableUnit
27.  def LastDischarge: Long
28.  def Magazine: Int
29.  def Magazine_=(mag: Int): Int
30.  def MaxAmmoSlot: Int
31.  def MaxMagazine: Int
32.  def NextAmmoType: equipment.Ammo.Value
33.  def NextFireMode: FireModeDefinition
    Definition Classes
      Tool → FireModeSwitch
34.  def Orientation: Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
35.  def Orientation_=(vec: Vector3): Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
36.  def Position: Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
37.  def Position_=(vec: Vector3): Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
38.  def Projectile: ProjectileDefinition
39.  def ProjectileType: ballistics.Projectiles.Value
40.  def Size: equipment.EquipmentSize.Value
    Definition Classes
      Equipment
41.  def Tile: InventoryTile
    Definition Classes
      Equipment
42.  def ToFireMode: Int
43.  def ToFireMode_=(index: Int): FireModeDefinition
44.  def Velocity: Option[Vector3]
    Definition Classes
      PlanetSideGameObject → WorldEntity
45.  def Velocity_=(vec: Option[Vector3]): Option[Vector3]
    Definition Classes
      PlanetSideGameObject → WorldEntity
46.  def Velocity_=(vec: Vector3): Option[Vector3]
    Definition Classes
      WorldEntity
47.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
48.  def blockMapEntry: Option[BlockMapEntry]

    internal data regarding an active representation on a blockmap

    internal data regarding an active representation on a blockmap

    Definition Classes
      BlockMapEntity
49.  def blockMapEntry_=(entry: Option[BlockMapEntry]): Option[BlockMapEntry]

    internal data regarding an active representation on a blockmap

    internal data regarding an active representation on a blockmap

    Definition Classes
      BlockMapEntity
50.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
51.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
52.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
53.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
54.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
55.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
56.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
57.  def isMoving(test: Float): Boolean

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    test

      the (squared) velocity to test against

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
58.  def isMoving(test: Vector3): Boolean

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    test

      the velocity to test against

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
59.  def isMoving: Boolean

    A velocity of non-zero is the same as moving.

    A velocity of non-zero is the same as moving.

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
60.  var lastDischarge: Long
61.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
62.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
63.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
64.  def sector(zone: Zone, range: Float): SectorPopulation

    Buckets in the blockmap are called "sectors".

    Buckets in the blockmap are called "sectors". Find the sectors in a given blockmap in which the entity would be represented within a given range.

    zone

      what region the blockmap represents

    range

      the custom distance from the central sector along the major axes

    returns

      a conglomerate sector which lists all of the entities in the allocated sector(s)

    Definition Classes
      BlockMapEntity
65.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
66.  def toString(): String
    Definition Classes
      Tool → Equipment → AnyRef → Any
67.  def updateBlockMapEntry(newCoords: Vector3): Boolean

    Update the internal data's known coordinate position without changing representation on whatever blockmap.

    Update the internal data's known coordinate position without changing representation on whatever blockmap. Has the potential to cause major issues with the blockmap if used without external checks.

    newCoords

      the coordinate position

    returns

      `true`, if the coordinates were updated; `false`, otherwise

    Definition Classes
      BlockMapEntity
68.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
69.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
70.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Inherited from JammableUnit

### Inherited from FireModeSwitch[FireModeDefinition]

### Inherited from Equipment

### Inherited from BlockMapEntity

### Inherited from FactionAffinity

### Inherited from PlanetSideGameObject

### Inherited from WorldEntity

### Inherited from IdentifiableEntity

### Inherited from Identifiable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped